package com.cool.hot100.linkedlist;

import org.junit.Test;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class Num142 {


    /**
     * Date 2024/8/21
     * DayNumber 2
     * Hard 2
     *
     * @param head
     * @return
     */
    public ListNode detectCycle(ListNode head) {

        // 空间复杂度O(n)
//        Map<ListNode,Integer> map=new HashMap<>();
//        while (head!=null){
//            if(map.containsKey(head)){
//                return head;
//            }
//            map.put(head,map.getOrDefault(head,0)+1);
//            head=head.next;
//        }
//        return null;

        // 空间复杂度O(1)
        if (head == null) return null;
        ListNode slow = head;
        ListNode fast = head;
        do {
            if (fast == null || fast.next == null) {
                return null;
            }
            slow = slow.next;
            fast = fast.next.next;
        } while (slow != fast);
        ListNode node = head;
        while (slow != node) {
            slow = slow.next;
            node = node.next;
        }
        return node;
    }

    @Test
    public void test() {
//        ListNode node=new ListNode(5,null);
        ListNode node1 = new ListNode(-4, null);
        ListNode node2 = new ListNode(0, node1);
        ListNode node3 = new ListNode(2, node2);
        ListNode node4 = new ListNode(3, node3);
        node1.next = node3;
        detectCycle(node4);
    }

}
